#include <bits/stdc++.h>
#define int long long

signed main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int t;
    std::cin >> t;

    while (t--)
    {
        int n, m;
        std::cin >> n >> m;

        std::vector<int> x(m);
        for (int i = 0; i < m; i++)
        {
            std::cin >> x[i];
        }

        int max = 0;
        for (int i = 1; i <= n; i++)
        {
            if (m % i == 0)
            {
                if ((m / i) % 2 == 0)
                {
                    max = std::max(max, i);
                }
                continue;
            }

            if ((m / i) % 2 == 0)
            {
                max = std::max(max, ((m % i)) * x[0]);
            }
            else
            {
                max = std::max(max, -((m - (m % i)) * x[0]));
            }
        }
        std::cout << max << std::endl;
    }
}